<script setup>
// imports
import { ref } from "vue";
import { MyTasks, FinishedTasks, DeletedTasks } from "../composables/Tasks";

// variables
let text = ref(null);
let form = ref(null);
let selectedTodo = ref(null);
let showDialog = ref(false);
let toMarkAsDone = ref(null);
let toDelete = ref(null);

// Function for adding todo task in MyTask List
const addTodo = () => {
  let id = MyTasks.value.length;
  MyTasks.value.push({
    id: ++id,
    todo: text.value,
  });

  text.value = null;
  form.value.reset();
};

// Function for selecting an individual task to be edited/updated
const selectTodo = (row) => {
  selectedTodo.value = row;
  text.value = row.todo;
};

// Function for editing/updating the selected todo task
const updateTodo = () => {
  let index = MyTasks.value.findIndex((t) => t.id === selectedTodo.value.id);
  index !== -1 && (MyTasks.value[index].todo = text.value);

  text.value = selectedTodo.value = null;
  form.value.reset();
};

// Function for displaying dialog box
const toggleDialog = (row, status) => {
  showDialog.value = true;
  toMarkAsDone.value = toDelete.value = null;
  status !== "delete" ? (toMarkAsDone.value = row) : (toDelete.value = row);
};

// Function for moving the individual task in the FinishedTasks list
const markAsDone = () => {
  // remove the individual task in the MyTasks list
  let index = MyTasks.value.findIndex((t) => t.id === toMarkAsDone.value.id);
  index !== -1 && MyTasks.value.splice(index, 1);
  //   push the task to the FinishedTasks array
  FinishedTasks.value.push(toMarkAsDone.value);
  toMarkAsDone.value = null;
  showDialog.value = false;
};

// Function for moving the individual task in the DeletedTasks list
const removeTodo = () => {
  // remove the individual task in the MyTasks list
  let index = MyTasks.value.findIndex((t) => t.id === toDelete.value.id);
  index !== -1 && MyTasks.value.splice(index, 1);

  //   push the task to the DeletedTasks array
  DeletedTasks.value.push(toDelete.value);
  toDelete.value = null;
  showDialog.value = false;
};
</script>

<template>
  <div class="flex justify-center">
    <div class="full-width q-pa-xl">
      <h6 class="q-my-none q-mb-md">My Tasks</h6>

      <!-- Task Input -->
      <q-form
        ref="form"
        @submit.prevent="!selectedTodo ? addTodo() : updateTodo()"
      >
        <div class="row gap">
          <q-input
            v-model="text"
            dense
            outlined
            label="What's your todo?"
            class="q-pa-none col-10"
            lazy-rules
            :rules="[(val) => !!val || 'Field is required']"
          />
          <div class="col-2 q-pl-sm">
            <q-btn
              :class="`bg-${!selectedTodo ? 'primary' : 'secondary'} fit`"
              color="white"
              glossy
              dense
              flat
              type="submit"
              :icon="!selectedTodo ? 'add' : 'edit'"
            />
          </div>
        </div>
      </q-form>

      <!-- Tasks Display -->
      <div class="q-mt-xl">
        <!-- Individual Task -->
        <q-card
          @click="selectTodo(row)"
          class="q-mt-sm"
          v-for="row in MyTasks"
          :key="row.id"
        >
          <q-card-section
            :class="`bg-${
              selectedTodo && selectedTodo.id === row.id
                ? 'secondary'
                : 'primary'
            } text-white q-pa-none flex justify-between items-center`"
          >
            <!-- Task name -->
            <div class="text-bold q-pl-lg">{{ row.todo }}</div>

            <div class="bg-white q-pa-sm">
              <!-- Mark as Done Btn -->
              <q-btn
                @click.stop="toggleDialog(row, 'mark-done')"
                flat
                icon="check_circle_outline"
                color="green"
              />

              <!-- Remove Btn -->
              <q-btn
                @click.stop="toggleDialog(row, 'delete')"
                flat
                icon="delete_outline"
                color="red"
              />
            </div>
          </q-card-section>
        </q-card>
      </div>
    </div>
  </div>

  <q-dialog v-model="showDialog" persistent>
    <q-card>
      <q-card-section class="row items-center">
        <div v-if="toMarkAsDone" class="q-ml-sm">
          Are you sure you want to mark
          <span class="text-green">"{{ toMarkAsDone.todo }}"</span> as done?
        </div>
        <div v-else class="q-ml-sm">
          Are you sure you want to delete
          <span class="text-green">"{{ toDelete.todo }}"</span>?
        </div>
      </q-card-section>

      <q-card-actions align="right">
        <q-btn flat label="Cancel" color="primary" v-close-popup />
        <q-btn
          @click="toMarkAsDone ? markAsDone() : removeTodo()"
          flat
          label="Yes"
          color="primary"
          v-close-popup
        />
      </q-card-actions>
    </q-card>
  </q-dialog>
</template>
